#ifndef __DATE_INTERVAL_HPP__
#define __DATE_INTERVAL_HPP__

#include <cstdint>

struct interval_t {

	enum unit_t {
		unknown,
		seconds,
		minutes,
		hours,
		days,
		weeks,
		months,
	};

	unit_t unit = unknown;
	uint64_t amount = 0;

	inline interval_t() noexcept = default;
	interval_t(unit_t, uint64_t amount) noexcept;

	static interval_t parse(uint64_t amount, const char * unit);
};

inline interval_t::interval_t(unit_t _unit, uint64_t _amount) noexcept
: unit(_unit), amount(_amount) {}

#endif
