#ifndef __SCHEDULER_HPP__
#define __SCHEDULER_HPP__

#include "task.hpp"
#include "event_handler.hpp"
#include <cstdint>
#include <map>
#include <set>

struct scheduler_t {

	int epollfd = -1;
	int signalfd = -1;
	int socketfd = -1;
	std::map<uint64_t, task_t> tasks;
	std::set<event_handler_t *> event_handlers;
	std::map<pid_t, uint64_t> processes;

	void start();
	void load_tasks();
	void register_handler(int fd, event_handler_t *);
	void unregister_handler(event_handler_t *);
};

extern scheduler_t scheduler;

#endif
