#ifndef __TASK_HPP__
#define __TASK_HPP__

#include "datetime.hpp"
#include "interval.hpp"
#include <cstdint>
#include <string>

struct task_t {

	uint64_t id;
	std::string script;
	std::string parameters;
	interval_t interval;
	datetime_t starting;
	datetime_t completed;
	datetime_t next_start;
	datetime_t next_run; // next start +/- fudge
	bool enabled;
	bool exact;
	bool oneshot;

	bool running() const;
	void execute() const;
	void reschedule(const datetime_t & now);

	static task_t parse(
		uint64_t id,
		const char * script,
		const char * parameters,
		const datetime_t & starting,
		const datetime_t & completed,
		const interval_t & interval,
		const char * enabled,
		const char * exact);
};

#endif
